/***************************************************************************
                          bookmarkbutton.h  -  description
                             -------------------
    begin                : t j 8 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BOOKMARKBUTTON_H
#define BOOKMARKBUTTON_H

#include <qtoolbutton.h>
#include <qpixmap.h>
#include "urldatabase/purldatabase.h"

/**
 * A popup-menu button that shows bookmarks in @ref PURLDatabase
 */
class BookmarkButton: public QToolButton {
    Q_OBJECT
public:
    BookmarkButton( QWidget *parent, const char *name = 0 );
    ~BookmarkButton();

signals:
    void listBookmark( const QString& );
    void listAsOtherPanel();
    void listHome();

private:
    PURLItemPtrList *bookmark_list;
    QPopupMenu *bookmarks_menu;
    QPixmap directory_icon;
    QPixmap home_icon;

private slots:
    void updateBookmarks();
    void gotoBookmark( int );
    void slotListAsOtherPanel();
};

#endif
