/***************************************************************************
                          pcmm.cpp  -  description
                             -------------------
    begin                : P be 22 12:46:35 CET 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pcmm.h"

#include <kaction.h>
#include <kstdaction.h>
#include <klocale.h>
#include <qpushbutton.h>

Pcmm *Pcmm::pcmm = 0;
KAction *Pcmm::quit = 0;        KToggleAction *Pcmm::ldir_line = 0;
KAction *Pcmm::conf = 0;        KToggleAction *Pcmm::lpath_combo = 0;
KAction *Pcmm::save = 0;        KToggleAction *Pcmm::linfo_line = 0;
KAction *Pcmm::delete_file = 0; KToggleAction *Pcmm::lhidden_files = 0;
KAction *Pcmm::mkdir = 0;       KAction *Pcmm::rpanel_conf = 0;
KAction *Pcmm::link = 0;        KToggleAction *Pcmm::rdir_line = 0;
KAction *Pcmm::rename = 0;      KToggleAction *Pcmm::rpath_combo = 0;
KAction *Pcmm::copy = 0;        KToggleAction *Pcmm::rinfo_line = 0;
KAction *Pcmm::move = 0;        KToggleAction *Pcmm::rhidden_files = 0;
KAction *Pcmm::gourl = 0;       KAction *Pcmm::view = 0;
KAction *Pcmm::go_file = 0;     KAction *Pcmm::edit = 0;
KAction *Pcmm::file_prop = 0;   KPopupMenu *Pcmm::file_menu = 0;
KAction *Pcmm::select = 0;      KPopupMenu *Pcmm::operations_menu = 0;
KAction *Pcmm::deselect = 0;    int Pcmm::file_menu_title_id = 0;
KAction *Pcmm::refresh = 0;     int Pcmm::file_menu_open_with_id = 0;
KAction *Pcmm::lpanel_conf = 0;
KAction *Pcmm::leftbookmarks = 0;
KAction *Pcmm::rightbookmarks = 0;
KAction *Pcmm::help = 0;
KAction *Pcmm::find = 0;
KAction *Pcmm::up = 0;
KAction *Pcmm::home = 0;
KAction *Pcmm::copy_clip = 0;
KAction *Pcmm::cut = 0;
KAction *Pcmm::paste = 0;
KAction *Pcmm::configurebookmarks = 0;

PURLDatabase *Pcmm::url_database = 0;
StdSlots *Pcmm::stdslots = 0;

Pcmm::Pcmm(QWidget *parent, const char *name) 
: KMainWindow(parent, name) {
    pcmm = this;
    url_database = new PURLDatabase;
    stdslots = new StdSlots();
    file_panel = new PDoubleFilePanel( this, "doublefilepanel" );

    setCentralWidget(file_panel);

    /* initActions() */
    quit = KStdAction::quit(kapp, SLOT( closeAllWindows() ), actionCollection());
//	quit->setStatusText(i18n("&Quits the application"));

    conf = KStdAction::preferences( SLOTS, SLOT( configure() ), actionCollection() );
    save = KStdAction::saveOptions( SLOTS, SLOT( saveApplicationOptions() ), actionCollection() );
    help = KStdAction::help( SLOTS, SLOT( invokeHelp() ), actionCollection() );
    find = KStdAction::find( SLOTS, SLOT( findFiles() ), actionCollection() );
    up = KStdAction::up( SLOTS, SLOT( GoUp() ), actionCollection() );
    home = KStdAction::home( SLOTS, SLOT( GoHome() ), actionCollection() );
    copy_clip = KStdAction::copy( SLOTS, SLOT( CopyClip() ), actionCollection() );
    cut = KStdAction::cut( SLOTS, SLOT( Cut() ), actionCollection() );
    paste = KStdAction::paste( SLOTS, SLOT( Paste() ), actionCollection() );

    delete_file = new KAction( i18n("&Delete..."), "editdelete", Key_F8, SLOTS, SLOT( Delete() ), actionCollection(), "deletefile" );
    mkdir = new KAction( i18n("&Make directory..."), "folder_new", Key_F7, SLOTS, SLOT( MkDir() ), actionCollection(), "mkdir" );
    link = new KAction( i18n("&Link..."), "link", CTRL+Key_L, SLOTS, SLOT( Link() ), actionCollection(), "link" );
    rename = new KAction( i18n("&Rename"), "edit", Key_F2, SLOTS, SLOT( Rename() ), actionCollection(), "rename" );
    copy = new KAction( i18n("&Copy..."), "editcopy", Key_F5, SLOTS, SLOT( Copy() ), actionCollection(), "copy" );
    move = new KAction( i18n("&Move..."), "move", Key_F6, SLOTS, SLOT( Move() ), actionCollection(), "move" );
    refresh = new KAction( i18n("&Refresh"), "reload", CTRL+Key_R, SLOTS, SLOT( Refresh() ), actionCollection(), "refresh" );
    select = new KAction( i18n("&Select files..."), "viewmag+", Key_Plus, SLOTS, SLOT( Select() ), actionCollection(), "select" );
    deselect = new KAction( i18n("&Deselect files..."), "viewmag-", Key_Minus, SLOTS, SLOT( Deselect() ), actionCollection(), "deselect" );
    gourl = new KAction( i18n("&Goto URL..."), "goto", Key_F9, SLOTS, SLOT( GoURL() ), actionCollection(), "gourl" );
    file_prop = new KAction( i18n("File &properties..."), "configure", CTRL+Key_P, SLOTS, SLOT( FileProperties() ), actionCollection(), "fileproperties" );
    go_file = new KAction( i18n("Open"), "key_enter", Key_Enter, SLOTS, SLOT( FileEntered() ), actionCollection(), "gofile" );

    lpanel_conf = new KAction( i18n("&Configure..."), "configure", CTRL+ALT+Key_C, LEFT_PANEL, SLOT( configureDlg() ), actionCollection(), "lpanelconf" );
    ldir_line = new KToggleAction( i18n("&Directory line"), CTRL+ALT+Key_D, LEFT_PANEL, SLOT( toggleDirectoryLine() ), actionCollection(), "ldirline" );
        ldir_line->setChecked( LEFT_PANEL->isDirectoryLine() );
        connect( LEFT_PANEL, SIGNAL( directoryLineShown( bool ) ), ldir_line, SLOT( setChecked( bool ) ) );
    lpath_combo = new KToggleAction( i18n("Path &combobox"), CTRL+ALT+Key_C, LEFT_PANEL, SLOT( togglePathCombobox() ), actionCollection(), "lpathcombo" );
        lpath_combo->setChecked( LEFT_PANEL->isPathCombobox() );
        connect( LEFT_PANEL, SIGNAL( pathComboboxShown( bool ) ), lpath_combo, SLOT( setChecked( bool ) ) );
    linfo_line = new KToggleAction( i18n("&Info line"), CTRL+ALT+Key_I, LEFT_PANEL, SLOT( toggleInfoLine() ), actionCollection(), "linfoline" );
        linfo_line->setChecked( LEFT_PANEL->isInfoLine() );
        connect( LEFT_PANEL, SIGNAL( infoLineShown( bool ) ), linfo_line, SLOT( setChecked( bool ) ) );

    rpanel_conf = new KAction( i18n("&Configure..."), "configure", CTRL+SHIFT+Key_C, RIGHT_PANEL, SLOT( configureDlg() ), actionCollection(), "rpanelconf" );
    rdir_line = new KToggleAction( i18n("&Directory line"), CTRL+SHIFT+Key_D, RIGHT_PANEL, SLOT( toggleDirectoryLine() ), actionCollection(), "rdirline" );
        rdir_line->setChecked( RIGHT_PANEL->isDirectoryLine() );
        connect( RIGHT_PANEL, SIGNAL( directoryLineShown( bool ) ), rdir_line, SLOT( setChecked( bool ) ) );
    rpath_combo = new KToggleAction( i18n("Path &combobox"), CTRL+SHIFT+Key_C, RIGHT_PANEL, SLOT( togglePathCombobox() ), actionCollection(), "rpathcombo" );
        rpath_combo->setChecked( RIGHT_PANEL->isPathCombobox() );
        connect( RIGHT_PANEL, SIGNAL( pathComboboxShown( bool ) ), rpath_combo, SLOT( setChecked( bool ) ) );
    rinfo_line = new KToggleAction( i18n("&Info line"), CTRL+SHIFT+Key_I, RIGHT_PANEL, SLOT( toggleInfoLine() ), actionCollection(), "rinfoline" );
        rinfo_line->setChecked( RIGHT_PANEL->isInfoLine() );
        connect( RIGHT_PANEL, SIGNAL( infoLineShown( bool ) ), rinfo_line, SLOT( setChecked( bool ) ) );

    view = new KAction( i18n("View"), Key_F3, SLOTS, SLOT( FileView() ), actionCollection(), "view" );
    edit = new KAction( i18n("Edit"), Key_F4, SLOTS, SLOT( FileEdit() ), actionCollection(), "edit" );

    leftbookmarks = new KAction( i18n("Bookmarks in Left Panel"), ALT+Key_F1, SLOTS, SLOT( leftBookmarks() ), actionCollection(), "leftbookmarks" );
    rightbookmarks = new KAction( i18n("Bookmarks in Right Panel"), ALT+Key_F2, SLOTS, SLOT( rightBookmarks() ), actionCollection(), "rightbookmarks" );
    configurebookmarks = new KAction( i18n( "Configure Bookmarks..." ), CTRL+Key_B, SLOTS, SLOT( configureBookmarks() ), actionCollection(), "configurebookmarks" );
    createGUI();
    
    file_menu = new KPopupMenu( this, "filepopupmenu" );
    copy_clip->plug( file_menu );
    cut->plug( file_menu );
    paste->plug( file_menu );
    file_menu->insertSeparator();
    delete_file->plug( file_menu );
    rename->plug( file_menu );
    file_menu->insertSeparator();
    go_file->plug( file_menu );
    file_menu_open_with_id = file_menu->insertItem( i18n("Open with..."), SLOTS, SLOT( OpenWith() ) );
    file_menu->insertSeparator();
    mkdir->plug( file_menu );
    file_menu->insertSeparator();
    find->plug( file_menu );
    file_menu->insertSeparator();
    select->plug( file_menu );
    deselect->plug( file_menu );
    file_menu->insertSeparator();
    file_prop->plug( file_menu );
    file_menu_title_id = file_menu->insertTitle( "filename", -1, 0 );

    operations_menu = new KPopupMenu( this, "operationspopupmenu" );
    mkdir->plug( operations_menu );
    operations_menu->insertSeparator();
    find->plug( operations_menu );
    operations_menu->insertSeparator();
    select->plug( operations_menu );
    deselect->plug( operations_menu );

    // ________________ button bar __________________
    button_bar = toolBar( "buttonbar" );
    button_bar->setFullSize();
    button_bar->setBarPos( KToolBar::Bottom );
    QWidget *w = new QWidget( button_bar );
    button_bar_layout = new QBoxLayout( w, QBoxLayout::LeftToRight );
    
    QPushButton *help_button = new QPushButton( i18n("F1 Help"), w, "helpbutton" );
    help_button->setFocusPolicy( QWidget::ClickFocus );
//	button_bar->insertWidget( 0, help_button->sizeHint().width(), help_button );
    button_bar_layout->addWidget( help_button );
    connect( help_button, SIGNAL( clicked() ), SLOTS, SLOT( invokeHelp() ) );
  
    QPushButton *rename_button = new QPushButton( i18n("F2 Rename"), w, "renamebutton" );
    rename_button->setFocusPolicy( QWidget::ClickFocus );
//	button_bar->insertWidget( 0, rename_button->sizeHint().width(), rename_button );
    button_bar_layout->addWidget( rename_button );
    connect( rename_button, SIGNAL( clicked() ), SLOTS, SLOT( Rename() ) );
    
    QPushButton *view_button = new QPushButton( i18n("F3 View"), w, "viewbutton" );
    view_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, view_button->sizeHint().width(), view_button );
    button_bar_layout->addWidget( view_button );
    connect( view_button, SIGNAL( clicked() ), SLOTS, SLOT( FileView() ) );
    
    QPushButton *edit_button = new QPushButton( i18n("F4 Edit"), w, "editbutton" );
    edit_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, edit_button->sizeHint().width(), edit_button );
    button_bar_layout->addWidget( edit_button );
    connect( edit_button, SIGNAL( clicked() ), SLOTS, SLOT( FileEdit() ) );
    
    QPushButton *copy_button = new QPushButton( i18n("F5 Copy"), w, "copybutton" );
    copy_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, copy_button->sizeHint().width(), copy_button );
    button_bar_layout->addWidget( copy_button );
    connect( copy_button, SIGNAL( clicked() ), SLOTS, SLOT( Copy() ) );
    
    QPushButton *move_button = new QPushButton( i18n("F6 Move"), w, "movebutton" );
    move_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, move_button->sizeHint().width(), move_button );
    button_bar_layout->addWidget( move_button );
    connect( move_button, SIGNAL( clicked() ), SLOTS, SLOT( Move() ) );
    
    QPushButton *mkdir_button = new QPushButton( i18n("F7 MkDir"), w, "mkdirbutton" );
    mkdir_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, mkdir_button->sizeHint().width(), mkdir_button );
    button_bar_layout->addWidget( mkdir_button );
    connect( mkdir_button, SIGNAL( clicked() ), SLOTS, SLOT( MkDir() ) );
    
    QPushButton *delete_button = new QPushButton( i18n("F8 Delete"), w, "deletebutton" );
    delete_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, delete_button->sizeHint().width(), delete_button );
    button_bar_layout->addWidget( delete_button );
    connect( delete_button, SIGNAL( clicked() ), SLOTS, SLOT( Delete() ) );
    
    QPushButton *go_button = new QPushButton( i18n("F9 Goto"), w, "gobutton" );
    go_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, go_button->sizeHint().width(), go_button );
    button_bar_layout->addWidget( go_button );
    connect( go_button, SIGNAL( clicked() ), SLOTS, SLOT( GoURL() ) );
    
    QPushButton *end_button = new QPushButton( i18n("End"), w, "endbutton" );
    end_button->setFocusPolicy( QWidget::ClickFocus ); 
//	button_bar->insertWidget( 0, end_button->sizeHint().width(), end_button );
    button_bar_layout->addWidget( end_button );
    connect( end_button, SIGNAL( clicked() ), kapp, SLOT( closeAllWindows() ) );

    button_bar->insertWidget( 0, w->sizeHint().width(), w );
    
    connect( button_bar, SIGNAL( orientationChanged( Orientation ) ), this, SLOT( buttonbarOrientationChanged() ) );
    button_bar->setEnableContextMenu( false );
    //-----------------------------------------------------------------------------
    
    readOptions();
}

Pcmm::~Pcmm() {
    delete url_database;
}

PDoubleFilePanel *Pcmm::filePanel() {
    return file_panel;
}

void Pcmm::saveOptions() {	
    KConfig *config = CONFIG;
    config->setGroup(GENERAL_KEY);
    config->writeEntry("Geometry", size());
    config->sync();
}

void Pcmm::readOptions() {
    KConfig *config = CONFIG;
    config->setGroup(GENERAL_KEY);
    QSize size=config->readSizeEntry("Geometry");
    if(!size.isEmpty()) {
            resize(size);
    }
}

void Pcmm::saveProperties(KConfig*) {
}

void Pcmm::readProperties(KConfig*) {
}

bool Pcmm::queryExit() {
	saveOptions();
	return true;
}

void Pcmm::buttonbarOrientationChanged() {
    Qt::Orientation o = button_bar->orientation();
    if (o == Qt::Vertical )
        button_bar_layout->setDirection( QBoxLayout::TopToBottom );
    else
        button_bar_layout->setDirection( QBoxLayout::LeftToRight );
}
