/***************************************************************************
                          looknfeel.h  -  description
                             -------------------
    begin                : P z 6 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOOKNFEEL_H
#define LOOKNFEEL_H

#include "panelconfigimpl.h"
#include <qframe.h>

/**
 * Widget contains several config tabs that are connected
 * with the look of the application as @ref PanelConfigImpl
 */
class LookNFeel: public QFrame {
    Q_OBJECT
public:
    LookNFeel( QWidget* parent, const char* name = 0 );
    ~LookNFeel();

public slots:
    void setup();
    void applyChanges();
    void defaultSettings();

private:
    PanelConfigImpl *left_panel_config;
    PanelConfigImpl *right_panel_config;
};

#endif
