/***************************************************************************
                          pconfig.cpp  -  description
                             -------------------
    begin                : P z 6 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pconfig.h"
#include <klocale.h>
#include <kapp.h>
#include <kiconloader.h>

#include "looknfeel.h"
#include "generalconfigimpl.h"
#include "advancedconfigimpl.h"

PConfig::PConfig( )
: KDialogBase( 0, 0, true, i18n("PCMM Configurator"), Default|Ok|Apply|Cancel ) {
//    setButtonApplyText( i18n("Defaults"), i18n("Reset ALL options to factory defaults"), 0 );
    setPlainCaption( i18n( "Configurator - Creating Your Own PCMM" ) );
    frames.setAutoDelete( true );
    widget = new KJanusWidget( this, 0, KJanusWidget::IconList );
    createLayout();
    setMainWidget( widget );
}

PConfig::~PConfig() {
}

void PConfig::newContent(QFrame *widget) {
    frames.append( widget );
    connect( this, SIGNAL( applyClicked() ), widget, SLOT( applyChanges() ) );
    connect( this, SIGNAL( defaultClicked() ), widget, SLOT( defaultSettings() ) );
}

void PConfig::createLayout() {
    // general
    newContent( new GeneralConfigImpl( widget->addPage(
		    i18n("General"),
		    i18n("General"),
		    QPixmap(kapp->iconLoader()->loadIcon("configure", KIcon::Desktop, 32 )))));
    // look n' feel
    newContent( new LookNFeel( widget->addPage(
		    i18n("Look & Feel"),
		    i18n("Look & Feel"),
		    QPixmap(kapp->iconLoader()->loadIcon("appearance", KIcon::Desktop,32)))));
    // advanced
    newContent( new AdvancedConfigImpl( widget->addPage(
		    i18n("Advanced"),
		    i18n("Advanced"),
		    QPixmap(kapp->iconLoader()->loadIcon("file_important", KIcon::Desktop,32)))));
    widget->showPage(0);
}

void PConfig::slotOk(){
    emit applyClicked();
    accept();
}
