/***************************************************************************
                          pdirectoryline.h  -  description
                             -------------------
    begin                : Mon May 6 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIRECTORYLINE_H
#define DIRECTORYLINE_H

#include "pdiskusagelabel.h"
#include "purllabel.h"
#include "bookmarkbutton.h"

/**
 * Widget that contains @ref BookmarkButton,
 * @ref PDiskUsageLabel and @ref PURLLabel
 */
class PDirectoryLine: public QWidget {
  Q_OBJECT
public:
    PDirectoryLine( QWidget *parent, const char *name );
    ~PDirectoryLine();

    PDiskUsageLabel *DULabel();
    PURLLabel *URLLabel();
    BookmarkButton *bookmarkButton();

    /**
     * parent widget becomes active - @ref PFilePanel
     */
    void focusInParent ();
    void focusOutParent ();

private:
    PDiskUsageLabel *du_label;
    PURLLabel *url_label;
    BookmarkButton *bookmark_button;
};

#endif
