#ifndef PFINDER_H
#define PFINDER_H

#include <qvariant.h>
#include <kdialog.h>
#include "query.h"
#include "searchquery.h"
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class KHistoryCombo;
class KLineEdit;
class KListView;
class QButtonGroup;
class QCheckBox;
class QGroupBox;
class QLabel;
class QListViewItem;
class QPushButton;
class QToolButton;
class KStatusBar;
class KPopupMenu;
class KSqueezedTextLabel;

class PFinder : public KDialog
{ 
    Q_OBJECT

public:
    PFinder( const QString& current_dir, QWidget* parent = 0, const char* name = 0 );
    ~PFinder();

    QToolButton* edit_button;
    QToolButton* cut_button;
    QToolButton* copy_button;
    QToolButton* stop_button;
    QToolButton* focus_button;
    QToolButton* view_button;
    QToolButton* delete_button;
    KListView* result_view;

    QPushButton* advanced_button;
    KLineEdit* advanced_line;

    QCheckBox* search_subdirectories;
    KHistoryCombo* lookin_combo;

    QPushButton* add_button;
    QPushButton* find_button;

    QCheckBox *name_case_sensitive;
    QCheckBox *name_regular_expression;
    QCheckBox *name_part_match;
    KHistoryCombo* named_combo;

    QCheckBox* search_content;
    KHistoryCombo *content_combo;
    QCheckBox *content_case_sensitive;
    QCheckBox *content_regular_expression;

    KSqueezedTextLabel *status_bar;


public slots:
    virtual void advancedOptions();
    virtual void copyFile();
    virtual void cutFile();
    virtual void deleteFile();
    virtual void editFile();
    virtual void focusFile();
    virtual void startSearching();
    virtual void stopSearching();
    virtual void viewFile();
    virtual void currentPath( const QString& );
    virtual void finished();

private:
    QString setQueryToAdvancedString();
    bool saveToQuery();

    QLabel *content_label;

    QVBoxLayout* GroupBox1Layout;
    QHBoxLayout* Layout8;
    QGridLayout* Layout11;

    bool file_content_shown;
    FinderQuery query;

    SearchQuery search;

    KPopupMenu *add_menu;

protected slots:
    void showSearchContent( bool show );
    void foundFiles( const KFileItemList& );
    void resultDelete( KIO::Job* );
    void addMntdDir();
    void addHomeDir();
    void addBrowsed();
};

#endif // PFINDER_H
