/***************************************************************************
                          searchquery.h  -  description
                             -------------------
    begin                : P j 4 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SEARCHQUERY_H
#define SEARCHQUERY_H

#include <qobject.h>
#include "query.h"
#include <kio/job.h>
#include <kfileitem.h>

class SearchQuery: public QObject {
    Q_OBJECT
public:
    SearchQuery( FinderQuery *query, QObject *parent, const char *name = 0 );
    ~SearchQuery();

    void start();
    void stop();

signals:
    void currentPath( const QString& path );
    void foundFiles( const KFileItemList& files );
    void finished();

private:
    bool searchContent( const QString file );
    KIO::ListJob *list_job;
    FinderQuery *query;
    QString last_dir;
    bool searching;
    bool stop_search;
    KFileItemList found_files;

private slots:
    void finished( KIO::Job* );
    void listedFiles( KIO::Job*, const KIO::UDSEntryList& );
    void slotCurrentPath( const KURL& );
};

#endif
