/***************************************************************************
                          pselectedfilesinfo.cpp  -  description
                             -------------------
    begin                : Sat Mar 23 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pselectedfilesinfo.h"
#include <klocale.h>

PSelectedFilesInfo::PSelectedFilesInfo(QWidget *parent, const char *name )
: QHBox( parent, name ), some_selected(false), m_current(new KFileItem( 16384, 493, KURL("/"), true )), 
	label1( new KSqueezedTextLabel( this ) ), label2( new QLabel( this ) ) {

	label1->setAlignment( Qt::AlignLeft );
	label2->setAlignment( Qt::AlignRight );
	setStretchFactor( label1, 1 );
}

PSelectedFilesInfo::~PSelectedFilesInfo(){
	delete m_current;
}

void PSelectedFilesInfo::currentFile( const KFileItem *file ){
	m_current->assign(*file);
	if (!some_selected) {
		if ( m_current->isLink() )
			label1->setText( QString("%1: %2: %3").arg(m_current->name() ).arg(i18n("link to") ).arg(m_current->linkDest() ) );
		else
			label1->setText( QString("%1: %2; %3; %4; %5/%6").arg(m_current->name())
				.arg(m_current->isDir() ? QString("DIR") : KIO::convertSize( m_current->size()))
				.arg(m_current->timeString())
				.arg(m_current->permissionsString())
				.arg(m_current->user() )
				.arg(m_current->group() ) );
	}
	else {
		if ( m_current->isLink() )
			label1->setText( QString("%1: %2").arg(m_current->name() ).arg(i18n("link") ));
		else if ( m_current->isDir() )
			label1->setText( QString("%1: %2").arg(m_current->name() ).arg(i18n("directory") ));
		else if ( m_current->isFile() )
			label1->setText( QString("%1: %2").arg(m_current->name() ).arg(KIO::convertSize( m_current->size() ) ) );
	}
}

void PSelectedFilesInfo::selectedFiles( const KFileItemList *list ){
	bool some_selected_old = some_selected;
	some_selected = list->count();
	if (some_selected_old != some_selected ) currentFile( m_current );
	if (some_selected) {
		KIO::filesize_t size = 0;
		KFileItemListIterator it(*list);
		for ( ; it.current() ; ++it )
			if ((*it)->isFile()) size += (*it)->size();
		label2->setText( QString("%1 in %2 selected %3")
				.arg(KIO::convertSize(size))
				.arg(list->count() )
				.arg(list->count() == 1 ? i18n("file") : i18n("files") ) );
	}
	else {
		label2->setText( QString::null );
	}
}
