/***************************************************************************
                          pviewer.h  -  description
                             -------------------
    begin                : Fri Mar 22 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIEWER_H
#define VIEWER_H

#include <qstring.h>
#include <kurl.h>
#include <keditcl.h>
#include <qwidget.h>

class KhtmlViewer;
/**
 * A wrapper-class for Pcmm's viewing abilities. PViewer is called statically
 * and runs the nessecery viewer.
 * Originaly, this class is from Krusader project
 */
class PViewer : public QObject {
    Q_OBJECT
public:
    static QString getTempFile();

    /**
     * This function is the only interface you'll ever need with PViewer, just call
     * the function with the name and mimetype (obtainable from it's vfile) and go!
     */
    static void view( QWidget *parent, QString fileName, QString mimetype);

    static void viewGeneric( QWidget *parent, QString fileName, QString mimetype, QString caption = QString::null);
    static void viewSpecial( QWidget *parent, QString fileName);
    static void viewText( QWidget *parent, QString fileName);
    static void viewImage( QWidget *parent, QString fileName);
    static void viewHex( QWidget *parent, QString fileName);
    PViewer() {} // a dummy constructor
};

class PEdit : public KEdit {
    Q_OBJECT
public:
    PEdit(QWidget* parent): KEdit(parent) {}
public slots:
    void search(){ KEdit::search(); }
};

#endif
