/***************************************************************************
                          stdslots.h  -  description
                             -------------------
    begin                : Ne j 6 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STDSLOTS_H
#define STDSLOTS_H

#include <qobject.h>
#include <kurl.h>

class StdSlots: public QObject {
    Q_OBJECT
public:
    StdSlots(){};
    ~StdSlots(){};

public slots:
    /**
     * Send request to delete selected files in active panel.
     */
    void Delete();
    void MkDir();
    void Link();
    void Rename();
    void Copy();
    void Move();
    void Refresh();
    void Select();
    void Deselect();
    void FileProperties();
    void FileEntered();
    void FileView();
    void FileEdit();
    void OpenWith();

    /**
     * Method that work with clipboard.
     */
    void CopyClip();
    void Cut();
    void Paste();
    
    /**
     * Show dialog for directory change
     */
    void GoURL();

    /**
     * List home directory
     */
    void GoHome();

    /**
     * List parent directory
     */
    void GoUp();

    void insertToURLDatabase( KURL& url );

    void leftBookmarks();
    void rightBookmarks();
    void configureBookmarks();

    void saveURLDatabase();
    void loadURLDatabase();

    /**
     * Show configure dialog of the application
     */
    void configure();

    /**
     * Save options of the application
     */
    void saveApplicationOptions();

    void invokeHelp();
    void findFiles();

};

#endif
