/***************************************************************************
                          purlitem.h  -  description
                             -------------------
    begin                : Mon May 13 2002
    copyright            : (C) 2002 by Tom Potrusil
    email                : potrto@centrum.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PURLITEM_H
#define PURLITEM_H

#include <kurl.h>
#include <qstring.h>
#include <qlist.h>

/**
 * @ref PURLDatabase operates with these items
 * @author Tom Potrusil
 */

class PURLItem {
public:
	PURLItem();
	PURLItem( const PURLItem& item );
	PURLItem( const KURL& url, bool is_bookmark = false );
	PURLItem( const KURL& url, const QString& name, bool is_bookmark = false );
	~PURLItem();

	PURLItem& operator=( const PURLItem& item );
	PURLItem& operator=( const KURL& url );
	bool operator== ( const PURLItem& item ) const;

	KURL& url();
	QString& name();
        bool isBookmark();
	void setURL( const KURL& url );
	void setURL( const QString& url );
	void setName( const QString& name );
        void setBookmark( bool is_bookmark = true );

private:
	KURL my_url;
	QString my_name;
        bool bookmark;
};

typedef QValueList<PURLItem> PURLItemList;
typedef QPtrList<PURLItem> PURLItemPtrList;

#endif
